/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the Flow type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Flow{}

// Flow Class Flow
type Flow struct {
	// Primary key of document. The value is null when document is not persisted.
	Id *string `json:"id,omitempty"`
	// Label
	Label interface{} `json:"label,omitempty"`
	// UserID
	UserId interface{} `json:"user_id,omitempty"`
	// Customer
	CustomerId interface{} `json:"customer_id,omitempty"`
	// The list of sources that are involved in the flow
	Source []FlowSource `json:"source,omitempty"`
	Tag    []string     `json:"tag,omitempty"`
	// The list of operations to be run in DPI on the data
	Operation   []FlowOperation `json:"operation,omitempty"`
	Api         *Api            `json:"api,omitempty"`
	WriteAction *WriteAction    `json:"write_action,omitempty"`
}

// NewFlow instantiates a new Flow object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFlow() *Flow {
	this := Flow{}
	return &this
}

// NewFlowWithDefaults instantiates a new Flow object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFlowWithDefaults() *Flow {
	this := Flow{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *Flow) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Flow) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *Flow) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *Flow) SetId(v string) {
	o.Id = &v
}

// GetLabel returns the Label field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Flow) GetLabel() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Flow) GetLabelOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return &o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *Flow) HasLabel() bool {
	if o != nil && IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given interface{} and assigns it to the Label field.
func (o *Flow) SetLabel(v interface{}) {
	o.Label = v
}

// GetUserId returns the UserId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Flow) GetUserId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.UserId
}

// GetUserIdOk returns a tuple with the UserId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Flow) GetUserIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.UserId) {
		return nil, false
	}
	return &o.UserId, true
}

// HasUserId returns a boolean if a field has been set.
func (o *Flow) HasUserId() bool {
	if o != nil && IsNil(o.UserId) {
		return true
	}

	return false
}

// SetUserId gets a reference to the given interface{} and assigns it to the UserId field.
func (o *Flow) SetUserId(v interface{}) {
	o.UserId = v
}

// GetCustomerId returns the CustomerId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Flow) GetCustomerId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.CustomerId
}

// GetCustomerIdOk returns a tuple with the CustomerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Flow) GetCustomerIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.CustomerId) {
		return nil, false
	}
	return &o.CustomerId, true
}

// HasCustomerId returns a boolean if a field has been set.
func (o *Flow) HasCustomerId() bool {
	if o != nil && IsNil(o.CustomerId) {
		return true
	}

	return false
}

// SetCustomerId gets a reference to the given interface{} and assigns it to the CustomerId field.
func (o *Flow) SetCustomerId(v interface{}) {
	o.CustomerId = v
}

// GetSource returns the Source field value if set, zero value otherwise.
func (o *Flow) GetSource() []FlowSource {
	if o == nil || IsNil(o.Source) {
		var ret []FlowSource
		return ret
	}
	return o.Source
}

// GetSourceOk returns a tuple with the Source field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Flow) GetSourceOk() ([]FlowSource, bool) {
	if o == nil || IsNil(o.Source) {
		return nil, false
	}
	return o.Source, true
}

// HasSource returns a boolean if a field has been set.
func (o *Flow) HasSource() bool {
	if o != nil && !IsNil(o.Source) {
		return true
	}

	return false
}

// SetSource gets a reference to the given []FlowSource and assigns it to the Source field.
func (o *Flow) SetSource(v []FlowSource) {
	o.Source = v
}

// GetTag returns the Tag field value if set, zero value otherwise.
func (o *Flow) GetTag() []string {
	if o == nil || IsNil(o.Tag) {
		var ret []string
		return ret
	}
	return o.Tag
}

// GetTagOk returns a tuple with the Tag field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Flow) GetTagOk() ([]string, bool) {
	if o == nil || IsNil(o.Tag) {
		return nil, false
	}
	return o.Tag, true
}

// HasTag returns a boolean if a field has been set.
func (o *Flow) HasTag() bool {
	if o != nil && !IsNil(o.Tag) {
		return true
	}

	return false
}

// SetTag gets a reference to the given []string and assigns it to the Tag field.
func (o *Flow) SetTag(v []string) {
	o.Tag = v
}

// GetOperation returns the Operation field value if set, zero value otherwise.
func (o *Flow) GetOperation() []FlowOperation {
	if o == nil || IsNil(o.Operation) {
		var ret []FlowOperation
		return ret
	}
	return o.Operation
}

// GetOperationOk returns a tuple with the Operation field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Flow) GetOperationOk() ([]FlowOperation, bool) {
	if o == nil || IsNil(o.Operation) {
		return nil, false
	}
	return o.Operation, true
}

// HasOperation returns a boolean if a field has been set.
func (o *Flow) HasOperation() bool {
	if o != nil && !IsNil(o.Operation) {
		return true
	}

	return false
}

// SetOperation gets a reference to the given []FlowOperation and assigns it to the Operation field.
func (o *Flow) SetOperation(v []FlowOperation) {
	o.Operation = v
}

// GetApi returns the Api field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Flow) GetApi() Api {
	if o == nil || IsNil(o.Api) {
		var ret Api
		return ret
	}
	return *o.Api
}

// GetApiOk returns a tuple with the Api field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Flow) GetApiOk() (*Api, bool) {
	if o == nil {
		return nil, false
	}
	return o.Api, o.Api != nil
}

// HasApi returns a boolean if a field has been set.
func (o *Flow) HasApi() bool {
	if o != nil && o.Api != nil {
		return true
	}

	return false
}

// SetApi gets a reference to the given NullableFlowApi and assigns it to the Api field.
func (o *Flow) SetApi(v Api) {
	o.Api = &v
}

// SetApiNil sets the value for Api to be an explicit nil
func (o *Flow) SetApiNil() {
	o.Api = nil
}

// UnsetApi ensures that no value is present for Api, not even an explicit nil
func (o *Flow) UnsetApi() {
	o.Api = nil
}

// GetWriteAction returns the WriteAction field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Flow) GetWriteAction() WriteAction {
	if o == nil || IsNil(o.WriteAction) {
		var ret WriteAction
		return ret
	}
	return *o.WriteAction
}

// GetWriteActionOk returns a tuple with the WriteAction field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Flow) GetWriteActionOk() (*WriteAction, bool) {
	if o == nil {
		return nil, false
	}
	return o.WriteAction, o.WriteAction != nil
}

// HasWriteAction returns a boolean if a field has been set.
func (o *Flow) HasWriteAction() bool {
	if o != nil && o.WriteAction != nil {
		return true
	}

	return false
}

// SetWriteAction gets a reference to the given NullableFlowWriteAction and assigns it to the WriteAction field.
func (o *Flow) SetWriteAction(v WriteAction) {
	o.WriteAction = &v
}

// SetWriteActionNil sets the value for WriteAction to be an explicit nil
func (o *Flow) SetWriteActionNil() {
	o.WriteAction = nil
}

// UnsetWriteAction ensures that no value is present for WriteAction, not even an explicit nil
func (o *Flow) UnsetWriteAction() {
	o.WriteAction = nil
}

func (o Flow) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Flow) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if o.Label != nil {
		toSerialize["label"] = o.Label
	}
	if o.UserId != nil {
		toSerialize["user_id"] = o.UserId
	}
	if o.CustomerId != nil {
		toSerialize["customer_id"] = o.CustomerId
	}
	if !IsNil(o.Source) {
		toSerialize["source"] = o.Source
	}
	if !IsNil(o.Tag) {
		toSerialize["tag"] = o.Tag
	}
	if !IsNil(o.Operation) {
		toSerialize["operation"] = o.Operation
	}
	if o.Api != nil {
		toSerialize["api"] = o.Api
	}
	if o.WriteAction != nil {
		toSerialize["write_action"] = o.WriteAction
	}
	return toSerialize, nil
}

type NullableFlow struct {
	value *Flow
	isSet bool
}

func (v NullableFlow) Get() *Flow {
	return v.value
}

func (v *NullableFlow) Set(val *Flow) {
	v.value = val
	v.isSet = true
}

func (v NullableFlow) IsSet() bool {
	return v.isSet
}

func (v *NullableFlow) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFlow(val *Flow) *NullableFlow {
	return &NullableFlow{value: val, isSet: true}
}

func (v NullableFlow) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFlow) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
